#pragma once

#cmakedefine01 ENGINE_HAS_GL
#cmakedefine01 ENGINE_HAS_GLX
#cmakedefine01 ENGINE_HAS_EGL
#cmakedefine01 ENGINE_HAS_VULKAN
#cmakedefine01 ENGINE_HAS_WAYLAND
#cmakedefine01 ENGINE_HAS_WGL
#cmakedefine01 ENGINE_HAS_XLIB

#ifndef ENGINE_IS_DEBUG
#define ENGINE_IS_DEBUG 0
#endif
#cmakedefine01 ENGINE_IS_LINUX
#cmakedefine01 ENGINE_IS_UNIX
#cmakedefine01 ENGINE_IS_WINDOWS

#define ENGINE_VERSION_MAJOR @ENGINE_VERSION_MAJOR@
#define ENGINE_VERSION_MINOR @ENGINE_VERSION_MINOR@
#define ENGINE_VERSION_PATCH @ENGINE_VERSION_PATCH@
#define ENGINE_VERSION_TWEAK @ENGINE_VERSION_TWEAK@

#ifdef __cplusplus
namespace engine::config {
constexpr auto const has_gl = ENGINE_HAS_GL == 1;
constexpr auto const has_glx = ENGINE_HAS_GLX == 1;
constexpr auto const has_egl = ENGINE_HAS_EGL == 1;
constexpr auto const has_vulkan = ENGINE_HAS_VULKAN == 1;
constexpr auto const has_wayland = ENGINE_HAS_WAYLAND == 1;
constexpr auto const has_wgl = ENGINE_HAS_WGL == 1;
constexpr auto const has_xlib = ENGINE_HAS_XLIB == 1;

constexpr auto const is_debug = ENGINE_IS_DEBUG == 1;
constexpr auto const is_linux = ENGINE_IS_LINUX == 1;
constexpr auto const is_unix = ENGINE_IS_UNIX == 1;
constexpr auto const is_windows = ENGINE_IS_WINDOWS == 1;
} // namespace engine::config
#endif
